import queue
import is_goal
import Sucessors


def BreadthFirstSearch(state):
    """accepts start state"""
    toDo = queue.Queue()
    toDo.put([state])
    explored = {state}
    while not toDo.empty():
        path = toDo.get()
        current = path[-1]
        if is_goal.isgoal(current):
            return path
        for next_state in Sucessors.sucessor(current):
            if not (next_state in explored):
                explored.add(next_state)
                path.append(next_state)
                toDo.put(path)
    return "Error Path not found"
